import { QueryClient } from '@kevisual/query';
import { QueryLoginBrowser } from '@kevisual/query-login';

export const query = new QueryClient();

export const queryLogin = new QueryLoginBrowser({
  query: query as any,
});

query.after(async (res, ctx) => {
  if (res.code === 401) {
    if (query.stop) {
      return {
        code: 500,
        success: false,
        message: '登录已过期.',
      };
    }
    query.stop = true;
    const result = await queryLogin.afterCheck401ToRefreshToken(res, ctx);
    query.stop = false;
    return result;
  }
  return res;
});
