type WxLoginConfig = {
  redirect_uri?: string;
  appid?: string;
  scope?: string;
  state?: string;
  style?: string;
};
export const createLogin = async (config?: WxLoginConfig) => {
  let redirect_uri = config?.redirect_uri;
  const { appid } = config || {};
  if (!redirect_uri) {
    redirect_uri = new URL(window.location.href).origin + '/api/s1/wx/login';
  }
  if (!appid) {
    console.error('appid is not cant be empty');
    return;
  }
  // @ts-ignore
  const obj = new WxLogin({
    self_redirect: false,
    id: 'weixinLogin', // 需要显示的容器id
    appid: appid, // 微信开放平台appid wx*******
    scope: 'snsapi_login', // 网页默认即可 snsapi_userinfo
    redirect_uri: encodeURIComponent(redirect_uri), // 授权成功后回调的url
    state: Math.ceil(Math.random() * 1000), // 可设置为简单的随机数加session用来校验
    stylelite: true, // 是否使用简洁模式
  });
  return obj;
};
export const wxId = 'weixinLogin';
export function setWxerwma(config?: WxLoginConfig) {
  const s = document.createElement('script');
  s.type = 'text/javascript';
  s.src = '//res.wx.qq.com/connect/zh_CN/htmledition/js/wxLogin.js';
  s.id = 'weixinLogin-js';
  if (document.getElementById('weixinLogin-js')) {
    createLogin(config);
    return;
  }
  const wxElement = document.body.appendChild(s);
  wxElement.onload = function () {
    createLogin(config);
  };
}
